package cn.iocoder.yudao.module.member.service.storeorder;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.controller.admin.storegoodsinventory.vo.AddReqVO;
import cn.iocoder.yudao.module.member.controller.admin.storeorder.vo.*;
import cn.iocoder.yudao.module.member.controller.app.store.dto.FacePayDto;
import cn.iocoder.yudao.module.member.controller.app.store.dto.StoreOrderDto;
import cn.iocoder.yudao.module.member.controller.app.store.dto.StoreOrderUploadDto;
import cn.iocoder.yudao.module.member.controller.app.store.vo.UserInfoVo;
import cn.iocoder.yudao.module.member.controller.app.storeorder.vo.AppStoreOrderVO;
import cn.iocoder.yudao.module.member.controller.app.storeorder.vo.CardDto;
import cn.iocoder.yudao.module.member.dal.dataobject.storeorder.StoreOrderDO;

import javax.validation.Valid;
import java.math.BigDecimal;
import java.util.List;

/**
 * 商品订单 Service 接口
 *
 * @author 管理员
 */
public interface StoreOrderService {

    /**
     * 创建商品订单
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Integer createStoreOrder(@Valid StoreOrderSaveReqVO createReqVO);

    /**
     * 更新商品订单
     *
     * @param updateReqVO 更新信息
     */
    void updateStoreOrder(@Valid StoreOrderSaveReqVO updateReqVO);

    /**
     * 删除商品订单
     *
     * @param id 编号
     */
    void deleteStoreOrder(Integer id);

    /**
     * 获得商品订单
     *
     * @param id 编号
     * @return 商品订单
     */
    StoreOrderDO getStoreOrder(Integer id);

    /**
     * 获得商品订单分页
     *
     * @param pageReqVO 分页查询
     * @return 商品订单分页
     */
    PageResult<StoreOrderDO> getStoreOrderPage(StoreOrderPageReqVO pageReqVO);

    StoreOrderDO createOrder(StoreOrderDto dto, Integer status);

    UserInfoVo facePay(FacePayDto dto);

    String cardPay(StoreOrderDto dto);

    AddReqVO codePay(StoreOrderDto dto);

    void batchCacheOrder(StoreOrderUploadDto dto);

    PageResult<StoreOrderPageVO> getStoreOrderPageNew(StoreOrderPageVO pageReqVO);

    List<StoreOrderPageVO> getStoreOrderPageNewList(StoreOrderPageVO pageReqVO);

    void reduction(Long orderId, BigDecimal money);

    AddReqVO appCreate(CardDto dto);

    void customize(StoreOrderCustomizeVO dto);

    String code(Integer orderId);

    AppStoreOrderVO info(String code);

    Boolean complete(Integer orderId);

    AddReqVO cancel(Integer orderId);

    Long refund(Integer orderId);

    List<StoreOrderDO> selectPayOrder();

    AddReqVO refundAdmin(Integer orderId);

    void completeList(List<Integer> orderIds);

    List<StoreOrderCountVO> countOrder(String startTime,String endTime);

    BigDecimal getDiscount(String equipmentCode);
}